#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"

using namespace cv;							

int main(){
	VideoCapture camera1(0);			  	//öffnet die jeweiligen Kameras
	

	//STEUERUNGSFENSTER
	namedWindow("Control",CV_WINDOW_NORMAL);
	int HSVValues[6];
	createTrackbar("lower_limit_Hue", "Control", &HSVValues[0], 255); //Hue 
	createTrackbar("upper_limit_Hue", "Control", &HSVValues[1], 255); // & damit es ein pointer ist, verstehe aber nicht ganz warum das notwendig ist und was das ändert
	createTrackbar("lower_limit_Sat", "Control", &HSVValues[2], 255); //Saturation
	createTrackbar("upper_limit_Sat", "Control", &HSVValues[3], 255);
	createTrackbar("lower_limit_Val", "Control", &HSVValues[4], 255); //Value
	createTrackbar("upper_limit_Val", "Control", &HSVValues[5], 255);

	while(true){
		Mat camera1_OG;					  	//Mat Variablen die die Bilddaten speichern 	
		camera1.read(camera1_OG);		  	//liest frame von camera und fügt es in Mat ein 
		imshow("camera1_OG", camera1_OG); 	//Darstellen des Bildes in einem Fenster
		waitKey(10); 		 				//Kurze Wartezeit zwischen den Iterationen der while Schleife, ohne dies Funktioniert der Code nicht


		Mat camera1_HSV;
		cvtColor(camera1_OG, camera1_HSV, COLOR_BGR2HSV); //Konvertiert den Frame von BGR zu HSV
		Mat camera1_Tresholded;
		inRange(camera1_HSV, Scalar(HSVValues[0], HSVValues[2], HSVValues[4]), Scalar(HSVValues[1], HSVValues[3], HSVValues[5]), camera1_Tresholded);

		//morphological opening (removes small objects from the foreground)
		erode(camera1_Tresholded, camera1_Tresholded, getStructuringElement(MORPH_ELLIPSE, Size(5, 5)) );
		dilate( camera1_Tresholded, camera1_Tresholded, getStructuringElement(MORPH_ELLIPSE, Size(5, 5)) ); 
		//morphological closing (removes small holes from the foreground)
		dilate( camera1_Tresholded, camera1_Tresholded, getStructuringElement(MORPH_ELLIPSE, Size(5, 5)) ); 
		erode(camera1_Tresholded, camera1_Tresholded, getStructuringElement(MORPH_ELLIPSE, Size(5, 5)) );

		Moments oMoments = moments(camera1_Tresholded);
		double dM01 = oMoments.m01;
		double dM10 = oMoments.m10;
		double dArea = oMoments.m00;

		imshow("Thresholded Image", camera1_Tresholded);

	}										//ENDE DER WHILE(TRUE)
} 											//ENDE DER MAIN